// FILE: par24bkd.h                Copyright (c), Symmetric Research, 1999
//
// This file contains constants and structure definitions that need
// to be shared between the kernel mode device driver and other code
// such as the Par24b DLL library and the driver installation/removal
// utility programs.
//
//


// Define device and registry strings

#define    DLL_DEVICE_NAME    "\\\\.\\Par24b"
#define     NT_DEVICE_NAME   L"\\Device\\Par24b0"
#define    DOS_DEVICE_NAME   L"\\??\\Par24b"
#define OLDDOS_DEVICE_NAME   L"\\DosDevices\\Par24b"
#define  DRIVER_CLASS_NAME   L"SR Par24b Kernel Driver Device"
#define    REG_DRIVER_NAME    "Par24b"
#define    REG_DRIVER_DESC    "Par24b A/D Device Driver"
#define    REG_DRIVER_GROUP   "Data Acquisition Devices"
#define    REG_PARM_PORTADDR  "PortAddress"
#define   LREG_PARM_PORTADDR L"PortAddress"
#define    REG_PARM_PORTMODE  "PortMode"
#define   LREG_PARM_PORTMODE L"PortMode"



// Define device type and access type for IOCTL functions
//
// Device types in the range 32768-65536 are for customer use (45678 = 0xB26E).

#define  PAR24B_DEVICE_TYPE  45678
#define  FILE_RW_ACCESS      (FILE_READ_ACCESS | FILE_WRITE_ACCESS)



// The I/O Control codes are used to indicate which function the
// hardware device should perform.
//
// The IOCTL function codes from 0x800 to 0xFFF are for customer use.

#define IOCTL_PAR24B_INIT \
    CTL_CODE( PAR24B_DEVICE_TYPE, 0x900, METHOD_BUFFERED, FILE_RW_ACCESS )

#define IOCTL_PAR24B_START \
    CTL_CODE( PAR24B_DEVICE_TYPE, 0x901, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_PAR24B_STOP \
    CTL_CODE( PAR24B_DEVICE_TYPE, 0x902, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_PAR24B_IS_EMPTY \
    CTL_CODE( PAR24B_DEVICE_TYPE, 0x903, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_PAR24B_IS_READY \
    CTL_CODE( PAR24B_DEVICE_TYPE, 0x904, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_PAR24B_OVERFLOW \
    CTL_CODE( PAR24B_DEVICE_TYPE, 0x905, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_PAR24B_READ_FIFO \
    CTL_CODE( PAR24B_DEVICE_TYPE, 0x906, METHOD_BUFFERED, FILE_READ_ACCESS )

#define IOCTL_PAR24B_USER_BYTE \
    CTL_CODE( PAR24B_DEVICE_TYPE, 0x907, METHOD_BUFFERED, FILE_WRITE_ACCESS )



// Define a structure to facilitate passing data between the DLL and
// the device driver.

typedef struct _Init24bParms {
        
             int PortAddress;
             int PortMode;

             int Dc;
             int Fp;
             int Gain;
             int CalMode;

    unsigned int FifoSize;
            long HI7190_CrValue;
             int ErrorCode;
        
        } INIT24BPARMS, *PINIT24BPARMS;

