/* FILE: simp24b.h              Copyright (c), Symmetric Research, 1998
 *
 * This include file has data structures that are common between simp24b.c
 * and downstream user processing.
 *
 *
 */



/* INI DATA:
 *
 *
 *
 *
 */

#define ON                      1
#define OFF                     0

#define NONE                    0          /* OutputFileMode values ... */
#define SINGLE                  1
#define SEQUENTIAL              2
#define TIME                    3

#define MAXCHANNELS             8

struct INI_data {

        char *Filename;


        /* User specified parameters. */

           int PortAddress;
           int PortMode;
  unsigned int FifoSize;

           int DataCoding;
        double SamplingRate;
           int Gain;
           int Calibration;

           int SystemStatus;
           int KeypressToRun;
           int ExitOnError;
           int DataDisplay;
           int InfoDisplay;
           int OutputFileMode;
 unsigned long Blocks;



        /* ... additional computed items ... */

           int FilterPoint;
        double TrueSamplingRate;

           int Channels;

  unsigned int Nvalues;
           int ChBufPts;
           int AcqBufSize;
 unsigned long OutputFileSize;
           
        double BufferTime;

        };









/* HDR DATA:
 *
 *
 *
 *
 *
 */

#define MAXTITLE                        12

struct HDR_data {

          char Id[32];

          long Channels;
          long RecordPts;
          long WordSize;
          long DataCoding;

        double SamplingRate;
        double Gain;
        double FilterCoeff;
        double FilterScale;

        struct channel_data { long channel; char title[ MAXTITLE]; }

                        ChannelList[ MAXCHANNELS];
        };
